/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000
// Ralf Westram
// Time-stamp: <Sat Dec/07/2002 13:49 MET Coder@ReallySoft.de>
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.  Ralf Westram makes no
// representations about the suitability of this software for any
// purpose.  It is provided "as is" without express or implied warranty.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef FW_COST_H
#define FW_COST_H

#ifndef __CTIME__
#include <ctime>
#endif

#ifndef INIFILE_H
#include "inifile.h"
#endif

//#define MKTIME_TEST
//#define DATE_CORRECTION

#if defined(DEBUG)
//#define DUMP_DBF_PARSING
//#define DUMP_SINGLE_COST_PARTS
//#define AUTO_ANSWER
//#define CHECK_FRIWEB_DBF // read contents of FRIWEB.DBF (for compare purposes only)
#endif // DEBUG

namespace fw_cost {

    // -----------------------------------------------------------------------------
    //      inline void section_______________________(const std::string& text)
    // -----------------------------------------------------------------------------
    inline void section_______________________(const std::string& text) {
        std::cout << "------------------------------------------------------------ " << text << ":\n";
    }
    //  -----------------------------------------------------
    //      inline std::string dateString(const struct tm *t)
    //  -----------------------------------------------------
    inline std::string dateString(const struct tm *t) {
#define BUFSIZE 100
        char buffer[BUFSIZE+1];
        strftime(buffer, BUFSIZE, "%d.%m.%Y", t);
        return std::string(buffer);
#undef BUFSIZE
    }
    //  ---------------------------------------------------------------------------
    //      inline std::string getEntryName(const char *entry_template, unsigned i)
    //  ---------------------------------------------------------------------------
    inline std::string getEntryName(const char *entry_template, unsigned i) {
#define BUFSIZE 50
        char  buf[BUFSIZE];
        strcpy(buf, entry_template);
        char *zero = strchr(buf, '0');
        if (!zero || zero[1]!='0') throw rs::err::InternalError(std::string("'")+entry_template+"' has to contain '00'");
        zero[0]    = '0'+i/10;
        zero[1]    = '0'+i%10;
        return buf;
#undef BUFSIZE
    }

    //  ------------------------------------------------------
    //      inline std::string getTaktungEntryName(unsigned i)
    //  ------------------------------------------------------
    inline std::string getTaktungEntryName(unsigned i) {
        return getEntryName("Taktung_00", i);
    }
    inline std::string getConnectionEntryName(unsigned i) {
        return getEntryName("Connection_00", i);
    }



}; // end of namespace fw_cost

#else
#error fw_cost.h included twice
#endif // FW_COST_H
