/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000
// Ralf Westram
// Time-stamp: <Sat Dec/07/2002 14:40 MET Coder@ReallySoft.de>
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.  Ralf Westram makes no
// representations about the suitability of this software for any
// purpose.  It is provided "as is" without express or implied warranty.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef OUTPUT_H
#define OUTPUT_H

#ifndef __STRING__
#include <string>
#endif
#ifndef __CTIME__
#include <ctime>
#endif

#ifndef KANAL_H
#include "Kanal.h"
#endif

namespace fw_cost {

    typedef bool (*sum_predicate)(const Connection&, const Connection&);
    typedef void (*prefix_writer)(std::ostream&, const Connection&);

    typedef size_t (*sum_categorizer)(const Connection&);
    typedef void (*category_prefix_writer)(std::ostream&, size_t category);

    void interpretConnections(const ConnectionList& connections, int max_pause, bool allowConnectionChange, bool einzel, bool detailed, bool provider);
    void printConnectionSums(const VerbindungenPtr verb, const ConnectionList& connections, const time_t& von, const time_t& bis, const std::string& zeitraum);
    void printSums(std::ostream& out, const ConnectionList& connections, const std::string& summenName, sum_predicate predicate, prefix_writer writePrefix, double& meanValue, int extraLastSum1, int extraLastSum2, bool for_each_provider);
    void printCategorizedSums(std::ostream& out, const ConnectionList& connections, const std::string& summenName, sum_categorizer categorize, category_prefix_writer writePrefix, bool for_each_provider);

    std::string timeString(const struct tm *t);
    std::string timeString(int seconds);
    inline std::string timeString(double seconds) { return timeString(int(seconds+0.5)); }


}; // end of namespace fw_cost

#else
#error output.h included twice
#endif // OUTPUT_H
